; Bels flash kezelse (csak ami itt szksges). Az adatlap alapjn,
; nhny mdostssal.

; Mentsi cm: 0f80h, ami a specilis terlet kezdcme
SAVE_H	EQU	0Fh
SAVE_L	EQU	80h

; Ezek a szubrutinok kizrlag arra valk, hogy a ktbjtos
; ber mutatt elmentsk ill. visszalltsk. Ehhez kt szt 
; (4 bjtot) rnak illetve olvasnak. A ments a wptr cmrl, a 
; visszaolvass a wpts cmre trtnik. Ezek ktbjtos vltozk.
; A flash cm mindig a ktbjtos SAVE s a kvetkez sz, ill. 
; trlsnl az azokat tartalmaz teljes sor.  

; A mentett mutat olvassa
READPTR
	BANKSEL PMADRL ; PMCON regiszterek helye
	MOVLW SAVE_L
	MOVWF PMADRL ; flash cm als bjtja
	MOVLW SAVE_H ;
	MOVWF PMADRH ; flash cm fels bjtja
	BCF PMCON1,CFGS ; Nem konfigurcis terlet!
	BSF PMCON1,RD ; olvass kezdemnyezse
	NOP ; (KTELEZ)
	NOP ; (KTELEZ)
	MOVF PMDATL,W ; a kiolvasott als bjt
	MOVWF WPTS ; a mentett mutat els bjtja
		   ; (a flash sz fels bjtja kzmbs)
	INCF PMADRL,F ; (tudjuk, hogy nem csordul tl)
	BCF PMCON1,CFGS ; Nem konfigurcis terlet!
	BSF PMCON1,RD ; olvass kezdemnyezse
	NOP ; (KTELEZ)
	NOP ; (KTELEZ)
	MOVF PMDATL,W ; a kiolvasott als bjt
	; a fels most is rtktelen
	MOVWF WPTS+1 ; a mentett mutat msodik bjtja
	RETURN
	
; A mentsre hasznlt flash sor trlse. Ments eltt ktelez!
; (A mentett mutat felhasznls utn azonnal trlhet, mivel
; induls utn hamarosan megvltozik. gy az j ments mr res
; sort tall, nem kell trlsre pazarolnia az idt.)
CLRFLASH
;	BCF INTCON,GIE ; mg nem is volt engedlyezve!
	BANKSEL PMADRL
	MOVLW SAVE_L ; mentsi cm als bjtja
	MOVWF PMADRL
	MOVLW SAVE_H ; mentsi cm fels bjtja
	MOVWF PMADRH
	BCF PMCON1,CFGS ; Nem konfigurcis terlet!
	BSF PMCON1,FREE ; Trls kvetkezik
	BSF PMCON1,WREN ; rsengedlyezs
	CALL FWRT
	BCF PMCON1,WREN ; Tovbbi rs tiltsa
;	BSF INTCON,GIE ; mg nem szabad
	RETURN
	
; Ments: wptr kt bjtjt rja ki 4 bjtra (az alsk a hasznosak).
SAVEPTR
;	BCF INTCON,GIE ; megszaktsban trtnik!
	BANKSEL PMADRH ; Bank 3
	MOVLW SAVE_H; Load initial address
	MOVWF PMADRH ;
	MOVLW SAVE_L ;
	MOVWF PMADRL ;
	MOVLW LOW WPTR ; els bjt cme
	MOVWF FSR0L ;
	MOVLW HIGH WPTR ; 
	MOVWF FSR0H ;
	BCF PMCON1,CFGS ; Nem konfigurcis terlet!
	BSF PMCON1,WREN ; rs engedlyezse
	BSF PMCON1,LWLO ; Csak a httrbjtokat
	MOVIW FSR0++ ; els bjt elhelyezse
	MOVWF PMDATL 
	MOVLW 3Fh
	MOVWF PMDATH ;  trlt llapotnak megfelel tartalom
	CALL FWRT; 1 sz rsa, LWLO=1 miatt a httrbe
	BCF PMCON1,LWLO ; A msodik mr tnyleg r majd
	INCF PMADRL,F ; kvetkez sz cmzse
	MOVIW FSR0++ ; msodik bjt (wptr+1)
	MOVWF PMDATL ;
	MOVLW 3Fh
	MOVWF PMDATH ;  trlt llapotnak megfelel tartalom
	CALL FWRT; 1 sz rsa, LWLO=0 miatt az egsz sort 
	; tnylegesen rja
	BCF PMCON1,WREN ; Tovbbi rsok tiltsa
;	BSF INTCON,GIE ; megszaktson bell vagyok!
	RETURN
	
; s az elemi r szubrutin
FWRT
	MOVLW 55h ; Ktelez szekvencia
	MOVWF PMCON2 ; Write 55h
	MOVLW 0AAh ;
	MOVWF PMCON2 ; Write AAh
	BSF PMCON1,WR ; rs indul
	NOP ; kt ktelez NOP
	NOP
	; httrrsnl ms vrakozs nincs, de LWLO=0 esetn
	; a tnyleges flash rs lelltja a program futst s
	; megvrja az rs vgt. A bels ra nem ll le, s
	; a perifrik is mkdnek. 
	RETURN
	
	