; ptrmac.inc: ktbjtos mutatkat kezel makrk. Ezek a makrk
; a prlx.inc fjlban tallhat makrkra tmaszkodnak.
; "mutat a mutatra" rsa fsr-be,igen gyakori az i2c rutinokban
wptpt0	macro	pointer	; fsr0-ba a spec bjtok kezdcme kerl
	movl	fsr0h,high pointer
	movl	fsr0l,low pointer
	endm
	
wptpt1	macro	pointer	; fsr1-be az adatbjtok kezdcme kerl
	movl	fsr1h,high pointer
	movl	fsr1l,low pointer
	endm

; mutat rsa fsr-be, fleg RAM-RAM adatmozgatsnl hasznos	
wrtpt0	macro	pointer	; mutat rsa fsr0-ba
	mov	fsr0h,pointer
	mov	fsr0l,pointer+1
	endm

wrtpt1	macro	pointer	; mutat rsa fsr1-be
	mov	fsr1h,pointer
	mov	fsr1l,pointer+1
	endm

; a visszamentsek sem az i2c miatt vannak	
wrbk0	macro	pointer	; mutat visszarsa fsr0-bl
	mov	pointer,fsr0h
	mov	pointer+1,fsr0l
	endm
	
wrbk1	macro	pointer	; mutat visszarsa fsr1-bl
	mov	pointer,fsr1h
	mov	pointer+1,fsr1l
	endm

; az i2c szubrutinok ltalban nem inkrementljk az EEPROM olvassi
; ill. rsi mutatt, ezrt gyakran kvetkezik utnuk ilyen makro:
; pointer a mutat els (magas) bjtja (vltoz), increment a 
; nvekmny (konstans). Ezek a makrk nem hasznlhatk az FSR-ek
; mdostsra, mivel azoknak az als bjtja van ell.
incpt	macro	pointer,increment ; mutat nvelse increment-tel
	movlw	increment
	addwf	pointer+1,f
	movlw	0
	addwfc	pointer,f
	endm	
decpt	macro	pointer,decrement ; ez meg dekrementlja
	movlw	decrement
	subwf	pointer+1,f
	movlw	0
	subwfb	pointer,f
	endm
; idpont bejegyzs csak 8-cal oszthat cmen kezddhet. Ez a kt
; makro ilyenre kerekt le- ill. felfel:	
rnddn8	macro	pointer	; levgja az als 3 bitet
	movlw	0xf8
	andwf	pointer+1,f
	endm		; a 8-cal oszthatt nem bntja
	
rndup8	macro	pointer	; felfel kerekt 8-cal oszthatra
	rnddn8	pointer
	incpt	pointer,8
	endm		; , de a 8-cal oszthatt is.	
	

