; conv. inc: konverzis s soros szubrutinok, A/D kezels.
; Indirekt cmzs esetn a forrst fsr0, a clt fsr1 cmzi. 
; Ciklusszervezs esetn egy-egy szmll is (scnt, rxcnt, ccount)
; felbukkan.

binhexu	; eljel nlkli binrisbl 2 hexadecimlis karakter
	swapf	indf0,w
	call	bhwlow
	moviw	fsr0++
bhwlow	; als 4 bit konvertlsa fsr1-gyel cmzett helyre
	andlw	0x0f
	iorlw	0x30
	movwf	indf1
	cjbl	indf1,0x3a,bhwsk
	movlw	7
	addwf	indf1,f
bhwsk
	moviw	fsr1++	; csak az inkrementls miatt!
	return
	
; ascii-bl tmr BCD, formtumellenrzs nlkl. fsr0 kettvel, 
; fsr1 1-gyel n, vagyis kaszkdolhat lenne. Kt bemen bjtot 
; hasznl fel!!!
asc2pbcd	
	moviw	fsr0++
	andlw	0x0f
	movwf	indf1
	swapf	indf1,f
	moviw	fsr0++
	andlw	0x0f
	iorwf	indf1,w
	movwi	fsr1++
	return

ehne	; v, hnap nap eebuf-bl a soros ad terletre
	bsf	datum
	movlw	low eebuf+7
	movwf	fsr0l
	movlw	high eebuf
	goto	sertim
opme	; ra, perc eebuf-bl soros ad terletre
	bcf	datum
	movlw	low eebuf+3
	movwf	fsr0l
	movlw	high eebuf
	goto	sertim
ehno	; v, nap, hnap rablokkbl a soros ad terletre
	bsf	datum
	movlw	low clkblk+6
	movwf	fsr0l
	movlw	high clkblk
	goto	sertim
opmo	; ra, perc rablokkbl soros ad terletre
	bcf	datum
	movlw	low clkblk+2
	movwf	fsr0l
	movlw	high clkblk
	goto	sertim
sertim	; soros id, ngyfle forrsterletrl
	movwf	fsr0h
	movlw	low sndblk
	movwf	fsr1l
	movlw	high sndblk
	movwf	fsr1h
	call	binhexu
	movlw	":"
	snb	datum
	movlw	"."
	movwi	fsr1++
	moviw	fsr0--	; csak a mutat miatt!
	moviw	fsr0--	; csak a mutat miatt!
	call	binhexu
	movlw	":"
	snb	datum
	movlw	"."
	movwi	fsr1++
	moviw	fsr0--
	moviw	fsr0--
	call	binhexu
	movlw	0x0d
	movwi	fsr1++
	movlw	0x0a
	movwi	fsr1++
	movlw	10
	movwf	scnt
	return
	
nhe	; nap, hnap, v vevbl rablokkba
	movlw	low clkblk+6
	goto	tocblk
mpo	; msodperc, perc ra vevbl rablokkba
	movlw	low clkblk+2
tocblk
	movwf	fsr1l
	movlw	high clkblk
	movwf	fsr1h
	movlw	low rcvblk
	movwf	fsr0l
	movlw	high rcvblk
	movwf	fsr0h
	call	asc2pbcd
	moviw	fsr0++	; szepartor kimarad
	moviw	fsr1--	; csak a mutat miatt
	moviw	fsr1--	; csak a mutat miatt	
	call	asc2pbcd
	moviw	fsr0++	; szepartor kimarad
	moviw	fsr1--
	moviw	fsr1--
	goto	asc2pbcd	; call asc2pbcd return helyett

; Ez kivtel: az ax, bx, cx dupla regisztert hasznlja.
; 2 bjt binrisrl (ah:al) 3 bjt tmr BCD-re (bl,ch,cl).
; bh-t szmllnak hasznlja.
; A mrt adatot konvertljuk vele. Az csak 10 bit, gy bl
; biztosan 0 lesz.
bibcd16
	movlw	16
	movwf	bh
	clrf	fsr0h
	clc
	clrf	bl
	clrf	ch
	clrf	cl
bibnul
	rlf	al,f
	rlf	ah,f
	decf	bh,f
	snz
	return
	sc
	goto	bibnul
	rlf	cl,f
	rlf	ch,f
	rlf	bl,f
	rlf	al,f
	rlf	ah,f
	rlf	cl,f
	rlf	ch,f
	rlf	bl,f
	decf	bh,f
	snz
	return
dhurok
	rlf	al,f
	rlf	ah,f
	rlf	cl,f
	rlf	ch,f
	rlf	bl,f
	decfsz	bh,f
	goto	dadj
	return
dadj
	movlw	cl
	movwf	fsr0l
	call	bcadj
	movlw	ch
	movwf	fsr0l
	call	bcadj
	movlw	bl
	movwf	fsr0l
	call	bcadj
	goto	dhurok
	
bcadj
	movlw	3
	addwf	indf0,w
	movwf	aux
	snb	aux,3
	movwf	indf0
	movlw	30h
	addwf	indf0,w
	movwf	aux
	snb	aux,7
	movwf	indf0
	return
; s a tmr BCD clbajuttatsra mr j a binhexu
; nhny hasznos karakter kldse, ez a program nem hasznlja
; mindegyiket.
txcr
	movlw	0dh
	goto	sersendw
txlf
	movlw	0ah
	goto	sersendw
txnl
	call	txcr
	goto	txlf
txpage
	movlw	0ch
	goto	sersendw
txpr
	movlw	">"
	goto	sersendw
txbel
	movlw	7
	goto	sersendw
txsp
	movlw	20h
	goto	sersendw
txbsp
	movlw	8
	goto	sersendw
	
	
txblk	; blokk adsa soros ad terletrl, hossza scnt-ben
	wptpt0	sndblk
sendnext
	moviw	fsr0++
	call	sersendw
	decfsz	scnt,f
	goto	sendnext
	return

sersendw ; soros ads w-bl. hurokban vrja az ad kirlst.
	banksel	pir1
txwait
	btfss	pir1,txif
	goto	txwait
	banksel	txreg
	movwf	txreg
	banksel	0
	return
	
serrecw	; soros vtel w-be. hurokban vrja a karakter megrkeztt.
	banksel	pir1
rcwait
	btfss	pir1,rcif
	goto	rcwait
	banksel	rcreg
	movf	rcreg,w
	banksel	0
	return

; szvegkld szubrutin, eltte a szveg kezdcmnek fels bjtjt
; a tpage, als bjtjt a tbase regiszterbe kell juttatni. Visszatrs
; utn pclath a szveg lapjra mutat, vissza kell lltani!!!	
szovegki
	movf	tpage,w
	movwf	pclath
	movf	tbase,w
	callw
	movlp	0
	iorlw	0	; a retlw utasts nem llt Z-t!
	snz	; nullra kilp
	return
	pagesel	sersendw
	call	sersendw
	incf	tbase,f
	goto	szovegki
	
menuout
	call	txpage
	movl	tpage, high mmenu
	movl	tbase, low mmenu
	call	szovegki
	clrf	pclath
	call	txnl
	call	txpr
	return
err1out
	movl	tpage,high idobaj
	movl	tbase,low idobaj
	call	szovegki
	clrf	pclath
	return
kiindul
	movl	tpage,high indul
	movl	tbase,low indul
	call	szovegki
	clrf	pclath
	return	
baki
	movl	tpage,high hiba
	movl	tbase,low hiba
	call	szovegki
	clrf	pclath
	return	
fffill8		; fsr1-gyel cmezve lerak 8 db ff-et ffblk-ba
	movlw	high ffblk
	movwf	fsr1h
	movlw	low ffblk
	movwf	fsr1l 
	movl	i2ccnt,8	; ilyenkor ms nem hasznlja
ffflp
	movlw	0xff
	movwi	fsr1++
	decfsz	i2ccnt,f
	goto	ffflp
	return
	  

		
		
	
	
	

	
	